%define 	sqlite_ver	10.4
%define 	mysql_ver	10.8
%define 	pgsql_ver	10.6

Name: parser3
Version: 3.4.6
Release: alt5
License: %gpl2only
Group: Development/Other
Packager: Anton Shevtsov <shevtsov.anton@gmail.com>
Summary: Parser 3, HTML-embedded scripting language
URL: http://parser3.ru

Patch0: parser3-3.4.6-pcre_path_fix.patch

Source0: https://github.com/artlebedev/parser3/archive/refs/tags/v%version.tar.gz
Source1: https://www.parser.ru/f/1/download/src/parser3sqlite-%{sqlite_ver}.tar.gz
Source2: https://www.parser.ru/f/1/download/src/parser3mysql-%{mysql_ver}.tar.gz
Source3: https://www.parser.ru/f/1/download/src/parser3pgsql-%{pgsql_ver}.tar.gz
Source4: NGINX.txt

Requires: libxml2 libxslt

BuildRequires: rpm-build-licenses
BuildRequires: libpcre-devel
BuildRequires: libgc-devel
BuildRequires: libxml2-devel
BuildRequires: libsqlite3-devel libmysqlclient21-devel postgresql-devel 
BuildRequires: libxslt-devel

#------------------------------------------------------- parser3-sqlite
%package -n %{name}-sqlite
Requires: %name
Group: Development/Other
Summary: sqlite3 driver for Parser3

%description -n %{name}-sqlite
SQLite driver for parser3
#------------------------------------------------------- parser3-sqlite

#------------------------------------------------------- parser3-mysql
%package -n %{name}-mysql
Requires: %name
Group: Development/Other
Summary: MySQL driver for Parser3

%description -n %{name}-mysql
MySQL driver for parser3
#------------------------------------------------------- parser3-mysql

#------------------------------------------------------- parser3-mysql
%package -n %{name}-pgsql
Requires: %name
Group: Development/Other
Summary: PostgreSQL driver for Parser3

%description -n %{name}-pgsql
PostgreSQL driver for parser3
#------------------------------------------------------- parser3-mysql


%description -l ru_RU.UTF-8
Parser 3 — простой и удобный объектно-ориентированный язык, позволяющий быстро создавать хорошие сайты

Это технология для самостоятельного создания сайтов с помощью простого языка. 
Parser начал создаваться в Студии Лебедева в 1997 году. Сегодня подавляющее 
большинство сайтов, создаваемых Студией Лебедева, делаются с его помощью.


%prep
%setup 
%patch -p1

#sqllite driver
tar -C src/sql/ -x -f %SOURCE1

#mysql driver
tar -C src/sql/ -x -f %SOURCE2

#pgsql driver
tar -C src/sql/ -x -f %SOURCE3

cp %SOURCE4 ./

%build
%configure --with-pcre=/usr --with-xml=/usr 

%make_build

#remeber root
pushd ./

#sqlite driver
cd src/sql/%{name}sqlite-%{sqlite_ver}
sed -i 's~^AM_CPPFLAGS = -I../../parser3/src/sql~AM_CPPFLAGS = -I../../sql~g' Makefile*

%configure
%make_build

popd
pushd ./

#mysql driver
cd src/sql/%{name}mysql-%{mysql_ver}
sed -i 's~^AM_CPPFLAGS = -I../../parser3/src/sql~AM_CPPFLAGS = -I../../sql~g' Makefile*

%configure
%make_build

popd

#pgsql driver
cd src/sql/%{name}pgsql-%{pgsql_ver}
sed -i 's~^AM_CPPFLAGS = -I../../parser3/src/sql~AM_CPPFLAGS = -I../../sql~g' Makefile*

%configure
%make_build

%install
mkdir -p %buildroot/%_sysconfdir/%name
mkdir -p %buildroot/%_datadir/%name/charsets

mkdir -p %buildroot/%_bindir/

cp src/targets/cgi/parser3 %buildroot/%_bindir/
cp etc/auto.p %buildroot/%_sysconfdir/%name/

# fix config dir
sed -i 's~^$confdir\[.*~$confdir\[/etc/parser3/\]~'  %buildroot/%_sysconfdir/%name/auto.p
# fix charset dir
sed -i 's~^\$charsetsdir\[.*~\$charsetsdir[/usr/share/parser3/charsets]~'  %buildroot/%_sysconfdir/%name/auto.p
# fix lib dir
sed -i 's~^$sqldriversdir\[.*~$sqldriversdir[/usr/lib64/parser3/]~' %buildroot/%_sysconfdir/%name/auto.p

#/usr/share/parser3/charsets/
cp etc/parser3.charsets/*.cfg %buildroot/%_datadir/%name/charsets/

# sqlitelib
mkdir -p %buildroot/%_libdir/%name
cp src/sql/parser3sqlite-%{sqlite_ver}/.libs/libparser3sqlite.so %buildroot/%_libdir/%name/

# mysqllib
cp src/sql/parser3mysql-%{mysql_ver}/.libs/libparser3mysql.so %buildroot/%_libdir/%name/

# pgsqllib
cp src/sql/parser3pgsql-%{pgsql_ver}/.libs/libparser3pgsql.so %buildroot/%_libdir/%name/


%files
%doc README AUTHORS COPYING NEWS NGINX.txt
%_sysconfdir/%name/auto.p
%_datadir/%name/*
%_bindir/%name

%files -n %{name}-sqlite
%_libdir/%name/libparser3sqlite.so

%files -n %{name}-mysql
%_libdir/%name/libparser3mysql.so

%files -n %{name}-pgsql
%_libdir/%name/libparser3pgsql.so

%changelog
* Fri Apr 14 2023 Anton Shevtsov <shevtsov.anton@gmail.com> - 3.4.6-alt5
- Compile with xml support

* Tue Jan 13 2022 Anton Shevtsov <shevtsov.anton@gmail.com> - 3.4.6-alt4
- Initial build
- add NGINX.txt
